VERSION 5.00
Begin VB.UserControl ctlTextComplete 
   ClientHeight    =   285
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1140
   ScaleHeight     =   285
   ScaleWidth      =   1140
   Begin VB.TextBox txtBase 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1140
   End
End
Attribute VB_Name = "ctlTextComplete"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Additional : -
'  Required ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Created ...: 2002/04/11 (yyyy/mm/dd)
'  Last update: 2002/04/11 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit

Private pxLastTextLen As Long
Private pxCompleteInProgress As Boolean

Private xItems() As String
Private xItemsCount As Long

Private xBackColor As OLE_COLOR
Private xCompareMethod As VbCompareMethod
Private xForeColor As OLE_COLOR
Private xText As String

Public Event Change()

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
  BackColor = xBackColor
End Property

Public Property Let BackColor(BackColor As OLE_COLOR)
  xBackColor = BackColor

  txtBase.BackColor = xBackColor

  PropertyChanged "BackColor"
End Property

Public Property Get CompareMethod() As VbCompareMethod
  CompareMethod = xCompareMethod
End Property

Public Property Let CompareMethod(CompareMethod As VbCompareMethod)
  xCompareMethod = CompareMethod

  PropertyChanged "CompareMethod"
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
  ForeColor = xForeColor
End Property

Public Property Let ForeColor(ForeColor As OLE_COLOR)
  xForeColor = ForeColor

  txtBase.ForeColor = xForeColor

  PropertyChanged "ForeColor"
End Property

Public Property Get Text() As String
Attribute Text.VB_ProcData.VB_Invoke_Property = ";Text"
  Text = xText
End Property

Public Property Let Text(Text As String)
  xText = Text

  txtBase.Text = xText

  PropertyChanged "Text"
End Property

Public Sub Clear()
  Erase xItems()
  xItemsCount = 0
End Sub

Public Sub AddItem(ByRef Text As String)
  ReDim Preserve xItems(0 To xItemsCount)
  xItems(xItemsCount) = Text
  xItemsCount = xItemsCount + 1
End Sub

Public Sub Complete()
  pxCompleteInProgress = True

  Dim tmpText As String, tmpTextLen As Long
  If xCompareMethod = vbBinaryCompare Then
    tmpText = txtBase.Text
  Else
    tmpText = LCase(txtBase.Text)
  End If
  tmpTextLen = Len(tmpText)

  Dim i As Long
  For i = 0 To xItemsCount - 1
    If xCompareMethod = vbBinaryCompare Then
      If xItems(i) = tmpText Then Exit For
    Else
      If LCase(Left$(xItems(i), tmpTextLen)) = tmpText Then Exit For
    End If
  Next i

  If i < xItemsCount Then
    txtBase.Text = xItems(i)
    txtBase.SelStart = Len(tmpText)
    txtBase.SelLength = Len(xItems(i)) - Len(tmpText)
  End If

  pxCompleteInProgress = False
End Sub

Private Sub txtBase_Change()
  If pxCompleteInProgress = True Then Exit Sub

  RaiseEvent Change

  Dim tmpCurrLen As Long
  tmpCurrLen = Len(txtBase.Text) - txtBase.SelLength

  If tmpCurrLen - pxLastTextLen = 1 Then Complete

  pxLastTextLen = Len(txtBase.Text) - txtBase.SelLength
End Sub

Private Sub UserControl_InitProperties()
  BackColor = vbWindowText
  CompareMethod = vbTextCompare
  ForeColor = vbWindowBackground
  Text = UserControl.Ambient.DisplayName
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  BackColor = PropBag.ReadProperty("BackColor", vbWindowBackground)
  CompareMethod = PropBag.ReadProperty("CompareMethod", vbTextCompare)
  ForeColor = PropBag.ReadProperty("ForeColor", vbWindowText)
  Text = PropBag.ReadProperty("Text", UserControl.Ambient.DisplayName)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  PropBag.WriteProperty "BackColor", BackColor, vbWindowBackground
  PropBag.WriteProperty "CompareMethod", CompareMethod, vbTextCompare
  PropBag.WriteProperty "ForeColor", ForeColor, vbWindowText
  PropBag.WriteProperty "Text", Text, UserControl.Ambient.DisplayName
End Sub

Private Sub UserControl_Resize()
  txtBase.Left = UserControl.ScaleLeft
  txtBase.Top = UserControl.ScaleTop
  txtBase.Width = UserControl.ScaleWidth
  txtBase.Height = UserControl.ScaleHeight
End Sub
