Attribute VB_Name = "mdlCRC32"
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Additional : -
'  Required ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Created ...: 2002/04/12 (yyyy/mm/dd)
'  Last update: 2002/04/12 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit


Private LookupTable(0 To 255) As Long

Public Sub CRC32Init()
  LookupTable(0) = &H0: LookupTable(1) = &H77073096: LookupTable(2) = &HEE0E612C: LookupTable(3) = &H990951BA: LookupTable(4) = &H76DC419: LookupTable(5) = &H706AF48F: LookupTable(6) = &HE963A535: LookupTable(7) = &H9E6495A3
  LookupTable(8) = &HEDB8832: LookupTable(9) = &H79DCB8A4: LookupTable(10) = &HE0D5E91E: LookupTable(11) = &H97D2D988: LookupTable(12) = &H9B64C2B: LookupTable(13) = &H7EB17CBD: LookupTable(14) = &HE7B82D07: LookupTable(15) = &H90BF1D91
  LookupTable(16) = &H1DB71064: LookupTable(17) = &H6AB020F2: LookupTable(18) = &HF3B97148: LookupTable(19) = &H84BE41DE: LookupTable(20) = &H1ADAD47D: LookupTable(21) = &H6DDDE4EB: LookupTable(22) = &HF4D4B551: LookupTable(23) = &H83D385C7
  LookupTable(24) = &H136C9856: LookupTable(25) = &H646BA8C0: LookupTable(26) = &HFD62F97A: LookupTable(27) = &H8A65C9EC: LookupTable(28) = &H14015C4F: LookupTable(29) = &H63066CD9: LookupTable(30) = &HFA0F3D63: LookupTable(31) = &H8D080DF5
  LookupTable(32) = &H3B6E20C8: LookupTable(33) = &H4C69105E: LookupTable(34) = &HD56041E4: LookupTable(35) = &HA2677172: LookupTable(36) = &H3C03E4D1: LookupTable(37) = &H4B04D447: LookupTable(38) = &HD20D85FD: LookupTable(39) = &HA50AB56B
  LookupTable(40) = &H35B5A8FA: LookupTable(41) = &H42B2986C: LookupTable(42) = &HDBBBC9D6: LookupTable(43) = &HACBCF940: LookupTable(44) = &H32D86CE3: LookupTable(45) = &H45DF5C75: LookupTable(46) = &HDCD60DCF: LookupTable(47) = &HABD13D59
  LookupTable(48) = &H26D930AC: LookupTable(49) = &H51DE003A: LookupTable(50) = &HC8D75180: LookupTable(51) = &HBFD06116: LookupTable(52) = &H21B4F4B5: LookupTable(53) = &H56B3C423: LookupTable(54) = &HCFBA9599: LookupTable(55) = &HB8BDA50F
  LookupTable(56) = &H2802B89E: LookupTable(57) = &H5F058808: LookupTable(58) = &HC60CD9B2: LookupTable(59) = &HB10BE924: LookupTable(60) = &H2F6F7C87: LookupTable(61) = &H58684C11: LookupTable(62) = &HC1611DAB: LookupTable(63) = &HB6662D3D

  LookupTable(64) = &H76DC4190: LookupTable(65) = &H1DB7106: LookupTable(66) = &H98D220BC: LookupTable(67) = &HEFD5102A: LookupTable(68) = &H71B18589: LookupTable(69) = &H6B6B51F: LookupTable(70) = &H9FBFE4A5: LookupTable(71) = &HE8B8D433
  LookupTable(72) = &H7807C9A2: LookupTable(73) = &HF00F934: LookupTable(74) = &H9609A88E: LookupTable(75) = &HE10E9818: LookupTable(76) = &H7F6A0DBB: LookupTable(77) = &H86D3D2D: LookupTable(78) = &H91646C97: LookupTable(79) = &HE6635C01
  LookupTable(80) = &H6B6B51F4: LookupTable(81) = &H1C6C6162: LookupTable(82) = &H856530D8: LookupTable(83) = &HF262004E: LookupTable(84) = &H6C0695ED: LookupTable(85) = &H1B01A57B: LookupTable(86) = &H8208F4C1: LookupTable(87) = &HF50FC457
  LookupTable(88) = &H65B0D9C6: LookupTable(89) = &H12B7E950: LookupTable(90) = &H8BBEB8EA: LookupTable(91) = &HFCB9887C: LookupTable(92) = &H62DD1DDF: LookupTable(93) = &H15DA2D49: LookupTable(94) = &H8CD37CF3: LookupTable(95) = &HFBD44C65
  LookupTable(96) = &H4DB26158: LookupTable(97) = &H3AB551CE: LookupTable(98) = &HA3BC0074: LookupTable(99) = &HD4BB30E2: LookupTable(100) = &H4ADFA541: LookupTable(101) = &H3DD895D7: LookupTable(102) = &HA4D1C46D: LookupTable(103) = &HD3D6F4FB
  LookupTable(104) = &H4369E96A: LookupTable(105) = &H346ED9FC: LookupTable(106) = &HAD678846: LookupTable(107) = &HDA60B8D0: LookupTable(108) = &H44042D73: LookupTable(109) = &H33031DE5: LookupTable(110) = &HAA0A4C5F: LookupTable(111) = &HDD0D7CC9
  LookupTable(112) = &H5005713C: LookupTable(113) = &H270241AA: LookupTable(114) = &HBE0B1010: LookupTable(115) = &HC90C2086: LookupTable(116) = &H5768B525: LookupTable(117) = &H206F85B3: LookupTable(118) = &HB966D409: LookupTable(119) = &HCE61E49F
  LookupTable(120) = &H5EDEF90E: LookupTable(121) = &H29D9C998: LookupTable(122) = &HB0D09822: LookupTable(123) = &HC7D7A8B4: LookupTable(124) = &H59B33D17: LookupTable(125) = &H2EB40D81: LookupTable(126) = &HB7BD5C3B: LookupTable(127) = &HC0BA6CAD
  
  LookupTable(128) = &HEDB88320: LookupTable(129) = &H9ABFB3B6: LookupTable(130) = &H3B6E20C: LookupTable(131) = &H74B1D29A: LookupTable(132) = &HEAD54739: LookupTable(133) = &H9DD277AF: LookupTable(134) = &H4DB2615: LookupTable(135) = &H73DC1683
  LookupTable(136) = &HE3630B12: LookupTable(137) = &H94643B84: LookupTable(138) = &HD6D6A3E: LookupTable(139) = &H7A6A5AA8: LookupTable(140) = &HE40ECF0B: LookupTable(141) = &H9309FF9D: LookupTable(142) = &HA00AE27: LookupTable(143) = &H7D079EB1
  LookupTable(144) = &HF00F9344: LookupTable(145) = &H8708A3D2: LookupTable(146) = &H1E01F268: LookupTable(147) = &H6906C2FE: LookupTable(148) = &HF762575D: LookupTable(149) = &H806567CB: LookupTable(150) = &H196C3671: LookupTable(151) = &H6E6B06E7
  LookupTable(152) = &HFED41B76: LookupTable(153) = &H89D32BE0: LookupTable(154) = &H10DA7A5A: LookupTable(155) = &H67DD4ACC: LookupTable(156) = &HF9B9DF6F: LookupTable(157) = &H8EBEEFF9: LookupTable(158) = &H17B7BE43: LookupTable(159) = &H60B08ED5
  LookupTable(160) = &HD6D6A3E8: LookupTable(161) = &HA1D1937E: LookupTable(162) = &H38D8C2C4: LookupTable(163) = &H4FDFF252: LookupTable(164) = &HD1BB67F1: LookupTable(165) = &HA6BC5767: LookupTable(166) = &H3FB506DD: LookupTable(167) = &H48B2364B
  LookupTable(168) = &HD80D2BDA: LookupTable(169) = &HAF0A1B4C: LookupTable(170) = &H36034AF6: LookupTable(171) = &H41047A60: LookupTable(172) = &HDF60EFC3: LookupTable(173) = &HA867DF55: LookupTable(174) = &H316E8EEF: LookupTable(175) = &H4669BE79
  LookupTable(176) = &HCB61B38C: LookupTable(177) = &HBC66831A: LookupTable(178) = &H256FD2A0: LookupTable(179) = &H5268E236: LookupTable(180) = &HCC0C7795: LookupTable(181) = &HBB0B4703: LookupTable(182) = &H220216B9: LookupTable(183) = &H5505262F
  LookupTable(184) = &HC5BA3BBE: LookupTable(185) = &HB2BD0B28: LookupTable(186) = &H2BB45A92: LookupTable(187) = &H5CB36A04: LookupTable(188) = &HC2D7FFA7: LookupTable(189) = &HB5D0CF31: LookupTable(190) = &H2CD99E8B: LookupTable(191) = &H5BDEAE1D

  LookupTable(192) = &H9B64C2B0: LookupTable(193) = &HEC63F226: LookupTable(194) = &H756AA39C: LookupTable(195) = &H26D930A: LookupTable(196) = &H9C0906A9: LookupTable(197) = &HEB0E363F: LookupTable(198) = &H72076785: LookupTable(199) = &H5005713
  LookupTable(200) = &H95BF4A82: LookupTable(201) = &HE2B87A14: LookupTable(202) = &H7BB12BAE: LookupTable(203) = &HCB61B38: LookupTable(204) = &H92D28E9B: LookupTable(205) = &HE5D5BE0D: LookupTable(206) = &H7CDCEFB7: LookupTable(207) = &HBDBDF21
  LookupTable(208) = &H86D3D2D4: LookupTable(209) = &HF1D4E242: LookupTable(210) = &H68DDB3F8: LookupTable(211) = &H1FDA836E: LookupTable(212) = &H81BE16CD: LookupTable(213) = &HF6B9265B: LookupTable(214) = &H6FB077E1: LookupTable(215) = &H18B74777
  LookupTable(216) = &H88085AE6: LookupTable(217) = &HFF0F6A70: LookupTable(218) = &H66063BCA: LookupTable(219) = &H11010B5C: LookupTable(220) = &H8F659EFF: LookupTable(221) = &HF862AE69: LookupTable(222) = &H616BFFD3: LookupTable(223) = &H166CCF45
  LookupTable(224) = &HA00AE278: LookupTable(225) = &HD70DD2EE: LookupTable(226) = &H4E048354: LookupTable(227) = &H3903B3C2: LookupTable(228) = &HA7672661: LookupTable(229) = &HD06016F7: LookupTable(230) = &H4969474D: LookupTable(231) = &H3E6E77DB
  LookupTable(232) = &HAED16A4A: LookupTable(233) = &HD9D65ADC: LookupTable(234) = &H40DF0B66: LookupTable(235) = &H37D83BF0: LookupTable(236) = &HA9BCAE53: LookupTable(237) = &HDEBB9EC5: LookupTable(238) = &H47B2CF7F: LookupTable(239) = &H30B5FFE9
  LookupTable(240) = &HBDBDF21C: LookupTable(241) = &HCABAC28A: LookupTable(242) = &H53B39330: LookupTable(243) = &H24B4A3A6: LookupTable(244) = &HBAD03605: LookupTable(245) = &HCDD70693: LookupTable(246) = &H54DE5729: LookupTable(247) = &H23D967BF
  LookupTable(248) = &HB3667A2E: LookupTable(249) = &HC4614AB8: LookupTable(250) = &H5D681B02: LookupTable(251) = &H2A6F2B94: LookupTable(252) = &HB40BBE37: LookupTable(253) = &HC30C8EA1: LookupTable(254) = &H5A05DF1B: LookupTable(255) = &H2D02EF8D
End Sub

Public Function CRC32GetDigest(ByRef Data() As Byte) As Long 'LBound(Data) must be 0
  On Error Resume Next

  Dim tmpCRC As Long, tmpC As Long
  tmpCRC = &HFFFFFFFF

  tmpC = UBound(Data()) - LBound(Data()) + 1
  If tmpC > 0 Then
    Dim i As Long
    For i = LBound(Data()) To UBound(Data())
      tmpCRC = pShiftRightLng8(tmpCRC) Xor LookupTable(tmpCRC And &HFF Xor Data(i))
    Next i
  End If

  CRC32GetDigest = tmpCRC Xor &HFFFFFFFF
End Function

Public Function CRC32GetHexFromString(ByRef Text As String, Optional ByVal UseUnicode As Boolean = True) As String
  Dim tmpB() As Byte, tmpDigest As String
  If UseUnicode = True Then
    tmpB() = Text
  Else
    tmpB() = StrConv(Text, vbFromUnicode)
  End If

  CRC32Init
  tmpDigest = Hex$(CRC32GetDigest(tmpB()))
  
  If Len(tmpDigest) < 8 Then
    CRC32GetHexFromString = String$(8 - Len(tmpDigest), "0") + tmpDigest
  Else
    CRC32GetHexFromString = tmpDigest
  End If
End Function



Private Function pShiftRightLng8(ByVal Data As Long) As Long
  Dim tmpData As Long
  tmpData = (Data And &H7FFFFFFF) \ 256
  If (Data And &H80000000) <> 0 Then
    tmpData = tmpData Or &H800000
  End If
  pShiftRightLng8 = tmpData
End Function
