'Class for encrypting and decrypting text.
'
'Author
'  Name .....: Josip Medved
'  E-mail ...: support@jmedved.com
'  URL ......: http://www.jmedved.com?findbytitle=rc4

'Information
'  Additional : -
'  Requires ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Last update: 2004-05-22 (yyyy-mm-dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.

Option Compare Binary
Option Explicit On 
Option Strict On

Public Class RC4

	Private Shared sBox(255) As Byte

	Public Overloads Shared Function GetEncrypt(ByVal data() As Byte, ByVal key() As Byte) As Byte()
		'Init key
		For i As Integer = 0 To sBox.Length - 1
			sBox(i) = CByte(i)
		Next i

		Dim tmpCount As Integer = UBound(key) + 1
		If tmpCount > 0 Then

			For i As Integer = 0 To tmpCount - 1
				Dim ii As Integer = (ii + sBox(i) + key(i Mod tmpCount)) Mod 256
				Swap(sBox(i), sBox(ii))
			Next i
		End If


		'Process data
		Dim tmpData() As Byte = data

		Dim j As Integer, k As Integer
		For i As Integer = 0 To UBound(tmpData)
			k = (k + 1) Mod 256
			j = (j + sBox(k)) Mod 256
			Swap(sBox(i), sBox(j))
			tmpData(i) = tmpData(i) Xor sBox((CInt(sBox(k)) + sBox(j)) Mod 256)
		Next i


		Return tmpData
	End Function

	Public Overloads Shared Function GetDecrypt(ByVal data() As Byte, ByVal key() As Byte) As Byte()
		Return GetEncrypt(data, key)
	End Function

	Public Overloads Shared Function GetEncrypt(ByVal data As String, ByVal key As String, Optional ByVal useUnicode As Boolean = True) As String
		Dim tmpData() As Byte
		If useUnicode = False Then
			Return System.Text.ASCIIEncoding.ASCII.GetString(GetEncrypt(System.Text.ASCIIEncoding.ASCII.GetBytes(data), System.Text.ASCIIEncoding.ASCII.GetBytes(key)))
		Else
			Return System.Text.UnicodeEncoding.Unicode.GetString(GetEncrypt(System.Text.UnicodeEncoding.Unicode.GetBytes(data), System.Text.UnicodeEncoding.Unicode.GetBytes(key)))
		End If
	End Function

	Public Overloads Shared Function GetDecrypt(ByVal data As String, ByVal key As String, Optional ByVal useUnicode As Boolean = True) As String
		Return GetEncrypt(data, key)
	End Function


	Private Shared Sub Swap(ByRef variable1 As Byte, ByRef variable2 As Byte)
		Dim s As Byte : s = variable1 : variable1 = variable2 : variable2 = s
	End Sub

	Private Shared Function UBound(ByVal array As Byte()) As Integer
		Try
			Return array.GetUpperBound(0)
		Catch ex As System.Exception
			Return -1
		End Try
	End Function

End Class
