'Last update: 2005-11-27
'Created ...: 2004-11-13
'Author ....: Josip Medved
'E-mail ....: jmedved@jmedved.com
'Web .......: http://www.jmedved.com
Option Compare Binary
Option Explicit On
Option Strict On

''' <summary>
''' Handles multiple instances.
''' </summary>
<System.CLSCompliant(False)> _
Public Class Highlander

	Private Shared _mtxFirstInstance As Threading.Mutex
	Private Shared _thrThread As New Threading.Thread(AddressOf Run)

	''' <summary>
	''' Raised when new instance is detected.
	''' </summary>
	''' <param name="sender">Object.</param>
	''' <param name="e">Parameters.</param>
	Public Shared Event NewInstanceDetected(ByVal sender As Object, ByVal e As NewInstanceEventArgs)

	''' <summary>
	''' Checks for another instance and sends it data if it exists.
	''' </summary>
	Shared Sub New()
		Dim refIsCreated As Boolean
		_mtxFirstInstance = New Threading.Mutex(True, Name, refIsCreated)
		IsAlreadyStarted = Not refIsCreated
		If IsAlreadyStarted = False Then
			_thrThread.Start()
		Else
			Dim ms As New IO.MemoryStream()
			Dim bf As New System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
			bf.Serialize(ms, New NewInstanceEventArgs(System.Environment.GetCommandLineArgs()))
			ms.Flush()

			Dim np As New NamedPipe(Name)
			np.OpenExisting()
			np.Write(ms.GetBuffer())
			np.Close()

			ms.Close()
		End If
	End Sub

	Private Shared _IsAlreadyStarted As Boolean
	''' <summary>
	''' Returns true if application was already started.
	''' </summary>
	''' <value>True if application is already started.</value>
	''' <returns>True if application is already started.</returns>
	Public Shared Property IsAlreadyStarted() As Boolean
		Get
			Return _IsAlreadyStarted
		End Get
		Private Set(ByVal value As Boolean)
			_IsAlreadyStarted = value
		End Set
	End Property

	Private Shared ReadOnly Property Name() As String
		Get
			Return System.Reflection.Assembly.GetEntryAssembly.FullName.Replace("\", "/")
		End Get
	End Property


	Private Shared Sub Run()
		Dim np As New NamedPipe(Name)
		np.Create()
		Do
			np.Connect()
			Dim b As Byte() = np.Read()
			np.Disconnect()

			Dim ms As New IO.MemoryStream(b)

			Dim bf As New System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
			Dim e As NewInstanceEventArgs = DirectCast(bf.Deserialize(ms), NewInstanceEventArgs)

			ms.Close()

			RaiseEvent NewInstanceDetected(Nothing, e)
		Loop
	End Sub

End Class
